/* vectors.h
   Copyright (C) 2012 J. A. Green <green8@sdf-eu.org>, If copyright allows, please addend copyright to additions to this source.
   lic: GNU GPL v3, see COPYING
*/
#ifndef VRT_VECTORS_H
#define VRT_VECTORS_H

struct vf {
	float x;
	float y;
	float z;
	float m;
};
typedef struct vf vf_t;

vf_t * set_vf(vf_t * a, float x, float y, float z, float m);
vf_t * cp_vf(vf_t * a, vf_t * b);
vf_t * form_mag_vf(vf_t * a);
vf_t * tele_mag_vf(vf_t * a, float m);
vf_t * tele_magz_vf(vf_t * a, float m);
vf_t * factor_vf(vf_t * a, float f);
float epd_vf(vf_t * a, vf_t * b);
vf_t * inv_vf(vf_t * a, vf_t * b);
vf_t * norm_vf(vf_t * a, vf_t * b);
vf_t * normz_vf(vf_t * a, vf_t * b);
float dprod_vf(vf_t * a, vf_t * b);
vf_t * cprod_vf(vf_t * a, vf_t * b, vf_t * c);
vf_t * icprod_vf(vf_t * a, vf_t * b, vf_t * c);
vf_t * sum_vf(vf_t * a, vf_t * b, vf_t * c);
float sum_mf(vf_t * a, vf_t * b);
vf_t * dif_vf(vf_t * a, vf_t * b, vf_t * c);
float dif_mf(vf_t * a, vf_t * b);
vf_t * mult_vf(vf_t * a, vf_t * b, vf_t * c);
float mult_mf(vf_t * a, vf_t * b);
vf_t * div_vf(vf_t * a, vf_t * b, vf_t * c);
float div_mf(vf_t * a, vf_t * b);

#endif /* VRT_VECTORS_H */
